#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

// #define MAX_DIST (1<<17) // put this back for optimal but SLOW compression
#define MAX_DIST 8192
#define MAX_LEN 1028
#define REL_OFFS 16383
		
FILE *f;
FILE *g;
char *in;
int reloffs[REL_OFFS+1]; // must be >= MAX_DIST+MAX_LEN
unsigned int bestlen,bestoffs;
unsigned int inlen,curpos,lastwrit;

/* unsigned int obestlen,obestoffs;
int ofind_match(unsigned int myoffs)
{
  unsigned int cur,len,mxlen;
  char *p1,*p2;

  obestlen=0; obestoffs=0;
  cur=myoffs;
  mxlen=inlen-myoffs; 
  if (mxlen>MAX_LEN) mxlen=MAX_LEN;
  while((cur>0)&&(myoffs<cur+MAX_DIST)) {
    cur--;
    len=0;
	p1=in+cur; p2=in+myoffs;
	while ((len<mxlen)&&(*(p1++)==*(p2++))) len++;
	if (len>obestlen) { obestlen=len; obestoffs=myoffs-cur; }
  }
  return obestlen;
}  */


int find_match(unsigned int myoffs)
{
  unsigned int cur,cur2,len,mxlen,i;
  char *p1,*p2;

  cur=myoffs;
  reloffs[myoffs&REL_OFFS]=0;
  bestlen=0; bestoffs=0;
  mxlen=inlen-myoffs; 
  if (mxlen>MAX_LEN) mxlen=MAX_LEN;
  cur=myoffs;
  while(1) {
  	if (reloffs[cur&REL_OFFS]==0) { /* undetermined */
		reloffs[cur&REL_OFFS]=-1;
		cur2=cur;
        while ((cur2>0)&&(myoffs<cur2+MAX_DIST)) {
    		cur2--;
			if ((in[cur2]==in[cur])&&(in[cur2+1]==in[cur+1])&&
	    		(in[cur2+2]==in[cur+2])) {
		  			reloffs[cur&REL_OFFS]=cur-cur2;
		  			break;
				}
  		}
	}
	if (reloffs[cur&REL_OFFS]==-1) break;
    cur-=reloffs[cur&REL_OFFS];
	if (myoffs>cur+MAX_DIST) break;
    len=0;
	p1=in+cur; p2=in+myoffs;
	while ((len<mxlen)&&(*(p1++)==*(p2++))) len++;
	if (len>bestlen) {
	  bestlen=len; bestoffs=myoffs-cur;
	}
  }
  if (bestoffs==0) return 0;
  for (i=myoffs+1;i<myoffs+bestlen;i++) reloffs[i&REL_OFFS]=0;
  return bestlen;
}

void do_write_block()
{
  int my_len;
  unsigned char head[4];
  /* write bytes lastwrit -> curpos-1 uncompressed, and a packing at curpos */

  while (curpos-lastwrit>=4) {
    my_len=(curpos-lastwrit)/4-1;
	if (my_len>0x1B) my_len=0x1B;
	head[0]=0xE0+my_len;
	fwrite(head,1,1,g);
	fwrite(in+lastwrit,1,my_len*4+4,g);
	lastwrit+=my_len*4+4;
  }
  my_len=curpos-lastwrit;
  if (bestlen==0) { /* stupid thing at eof */
    head[0]=0xFC+my_len;
	fwrite(head,1,1,g);
    if (my_len==0) return;
	fwrite(in+lastwrit,1,my_len,g);
	lastwrit=curpos;
	return;
  }
  if ((bestlen<=10)&&(bestoffs<=1024)) {
    head[0]=(((bestoffs-1)>>8)<<5)
			+ ((bestlen-3)<<2) + my_len;
	head[1]=(bestoffs-1)&0xff;
	fwrite(head,1,2,g);
	fwrite(in+lastwrit,1,my_len,g);
	curpos=lastwrit=curpos+bestlen;
	return;
  }
  if ((bestlen<=67)&&(bestoffs<=16384)) {
    head[0]=0x80+(bestlen-4);
	head[1]=(my_len<<6) + ((bestoffs-1)>>8);
	head[2]=(bestoffs-1)&0xff;
	fwrite(head,1,3,g);
	fwrite(in+lastwrit,1,my_len,g);
	curpos=lastwrit=curpos+bestlen;
	return;
  }
  if ((bestlen<=MAX_LEN)&&(bestoffs<=MAX_DIST)) {
    bestoffs--;
    head[0]=0xC0+((bestoffs>>16)<<4)+(((bestlen-5)>>8)<<2)+my_len;
	head[1]=(bestoffs>>8)&0xff;
	head[2]=bestoffs&0xff;
	head[3]=(bestlen-5)&0xff;
	fwrite(head,1,4,g);
	fwrite(in+lastwrit,1,my_len,g);
	curpos=lastwrit=curpos+bestlen;
	return;
  }
  printf("What happened ? bestlen = %d bestoffs = %d\n",bestlen,bestoffs);
}

int main(int argc,char **argv)
{
	char hd[5];

	if (argc<3) {
		puts("Usage: QFPACK infile.FSH outfile.QFS");
		exit(1);
	}
	f=fopen(argv[1],"rb");
	fseek(f,0,SEEK_END);
	inlen=ftell(f);
	rewind(f);
	in=malloc(inlen+3); // for safety in looking at eof
	if ((curpos=fread(in,1,inlen,f))!=inlen) {
		printf("BUG FILESIZE %d %d\n",inlen,curpos);
		exit(1);
	}
	fclose(f);
	g=fopen(argv[2],"wb");
	
	hd[0]=0x10; hd[1]=(char)0xFB;
	hd[2]=inlen>>16; hd[3]=(inlen>>8)&255; hd[4]=inlen&255;
	fwrite(hd,1,5,g);
	curpos=0; lastwrit=0;
	while (curpos<inlen) {
	  if ((curpos&255)==0) printf("%d ",curpos);
	  find_match(curpos);
/*	  ofind_match(curpos);
	  if ((obestlen!=bestlen)&&(obestlen>=3))
	    printf("incoherent at %d, old=%d l%d new=%d l%d\n",
		  curpos,obestoffs,obestlen,bestoffs,bestlen); */
	  if ((bestlen>=5)||
	      ((bestlen==4)&&(bestoffs<=16384))||
	      ((bestlen==3)&&(bestoffs<=1024)))
		 do_write_block();
	  else curpos++;
	}
	bestlen=0;
	do_write_block();
	fclose(g);
	return 0;
}
