#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

/* void copy(char *dest,char *src,int count)
{
	while (count--) *(dest++)=*(src++);
} */

unsigned char* ReadPackFile(unsigned char *pSourceData,int filesize,
								int *outlen)
{
	int PackCode,ExpandedLength,filepos,TargetOffset;
	unsigned char *pExpandedData;
	unsigned char pack_byte,*pSrc,*pDest;
	int a,b,c,len,offset;

    PackCode = (pSourceData[0]&0xfe)*256 + pSourceData[1];
    if (PackCode != 0x10fb){
        free(pSourceData);
        return(NULL);                   // Invalid pack code
    }
    ExpandedLength = (pSourceData[2] << 16) + (pSourceData[3] << 8)
                         + pSourceData[4];
	*outlen=ExpandedLength;
    filepos = 5;
    TargetOffset = 0;
    if (pSourceData[0] & 0x01) filepos = 8;   // align if necessary.

    pExpandedData = (unsigned char *)malloc(ExpandedLength);
    if (pExpandedData){
        while(filepos < filesize && pSourceData[filepos] < 0xfc){
            pack_byte = pSourceData[filepos];
            a = pSourceData[filepos+1];
            b = pSourceData[filepos+2];
            if (!(pack_byte & 0x80)){
                len = pack_byte&0x03;
                pDest = pExpandedData+TargetOffset;
                pSrc = pSourceData+filepos+2;
                TargetOffset += len;
                filepos += (len+2);
                while (len--) *pDest++ = *pSrc++;
                len = ((pack_byte & 0x1c)>>2) + 3;
//              offset = (pack_byte >> 5) + a + 1;
                offset = ((pack_byte >> 5)<<8) + a + 1;
                pDest = pExpandedData + TargetOffset;
                pSrc = pDest-offset;
                TargetOffset += len;
                while (len--) *pDest++ = *pSrc++;
            }
            else if (!(pack_byte & 0x40)){
                len = (a >> 6) &0x03;
                pDest = pExpandedData + TargetOffset;
                pSrc = pSourceData+filepos+3;
                filepos += (len+3);
                TargetOffset += len;
                while (len--) *pDest++ = *pSrc++;
                offset = (a&0x3f)*256 + b + 1;
                pDest = pExpandedData + TargetOffset;
                pSrc = pDest-offset;
                len = (pack_byte & 0x3f)+4;
                TargetOffset += len;
                while (len--) *pDest++ = *pSrc++;
            }
            else if (!(pack_byte & 0x20)){
                c = pSourceData[filepos+3];
                len = (pack_byte & 0x03);
                pDest = pExpandedData + TargetOffset;
                pSrc = pSourceData+filepos+4;
                filepos += (len+4);
                TargetOffset += len;
                while (len--) *pDest++ = *pSrc++;
                offset = ((pack_byte & 0x10)<<0x0c) + 256*a + b + 1;
                pDest = pExpandedData + TargetOffset;
                pSrc = pDest-offset;
                len = ((pack_byte >> 2)&0x03)*256+c+5;
                TargetOffset += len;
                while (len--) *pDest++ = *pSrc++;
            }
            else {
                len = (pack_byte&0x1f)*4+4;
                pDest = pExpandedData + TargetOffset;
                pSrc = pSourceData+filepos+1;
                filepos += (len+1);
                TargetOffset += len;
                while (len--) *pDest++ = *pSrc++;
            }
        }
        if (filepos < filesize && TargetOffset < ExpandedLength){
            pDest = pExpandedData + TargetOffset;
            pSrc = pSourceData+filepos+1;
            len = pSourceData[filepos]&0x03;
            while (len--) *pDest++ = *pSrc++;
        }
    }
    free(pSourceData);
    return(pExpandedData);
}

int main(int argc,char **argv)
{
	FILE *f;
	FILE *g;
	char *in,*out;
	unsigned int inlen,outlen;

	if (argc<3) {
		puts("Usage: QFS infile.QFS outfile.FSH");
		exit(1);
	}
	f=fopen(argv[1],"rb");
	fseek(f,0,SEEK_END);
	inlen=ftell(f);
	rewind(f);
	in=malloc(inlen);
	if ((outlen=fread(in,1,inlen,f))!=inlen) {
		printf("BUG FILESIZE %d %d\n",inlen,outlen);
		exit(1);
	}
	fclose(f);
	out=ReadPackFile(in,inlen,&outlen);
	if (out==NULL) { 
		puts("BUG OUTBUFFER");
		exit(1);
	}
	g=fopen(argv[2],"wb");
	fwrite(out,1,outlen,g);
	fclose(g);
	return 0;
}
